Subject: Re: bug#15899: 24.3.50; regression: `region' overlay is lower priority than default

From: Eli Zaretskii <[email-masked]>
Date: Sat, 16 Nov 2013 11:06:41 +0200

> From: Stefan Monnier <[email-masked]>
> Cc: [email-masked],  [email-masked]
> Date: Fri, 15 Nov 2013 20:25:46 -0500
> 
> > Isn't it confusing that the region highlighting is non-contiguous when
> > an overlay is in its middle?
> 
> 1- you need more than "an overlay in its middle": you need this overlay
>    to put a face property that happens to completely cancel the region's
>    own face properties (since the `face' properties of overlapping
>    overlays are merged).

It's enough for that face to specify a background color, no?  That's
not uncommon for Emacs features.  E.g., try "M-x hl-line-mode RET".

> 2- I don't think it's particularly confusing, no.  Usually the context
>    makes it pretty clear, and if the user is surprised at some point,
>    that surprise will most likely not last very long.

Well, a few people just disagreed with you.

> > What are the downsides of setting the region overlay's priority to
> > most-positive-fixnum?
> 
> I most-positive-fixnum-ly hate overlay priorities.

No offense, but I think we can live with that downside ;-)
Are there any others?

In any case, the moment you reimplemented the region as an overlay,
you got us this issue, because it is inherent in the use of overlays,
and cannot be escaped.